#include<iostream>
#include<time.h>
#include<string.h>
#include<errno.h>

std::ostream& operator<<(std::ostream& str,const struct timespec& res)
{
   str << res.tv_sec << "s " << res.tv_nsec << "ns ";
   return str;
}

int main(int,char **)
{
  struct timespec resMono;
  struct timespec resReal;
  int r=0;

  r=clock_getres(CLOCK_MONOTONIC,&resMono);
  if(r<0)
  {       std::clog << "clock_getres(CLOCK_MONOTONIC): "
                    << strerror(errno) << std::endl;
  }
  std::cout << "Resolution MONOTONIC\t" << resMono << std::endl;
  r=clock_getres(CLOCK_REALTIME,&resMono);
  if(r<0)
  {       std::clog << "clock_getres(CLOCK_REALTIME): "
                    << strerror(errno) << std::endl;
  }
  std::cout << "Resolution REALTIME\t" << resMono << std::endl;
}
