#include<time.h>
#include<sys/time.h>
#include<iostream>
#include"TSCtimestamp.h"

inline std::ostream& operator<<(std::ostream& str,const struct timespec& ts)
{
  str << ts.tv_sec << ':' << ts.tv_nsec;
  return str;
}

int main(int argc,char **argv)
{
  struct timeval currentgtofday;
  TSCTimestamp_t lasttsc,currenttsc;
  struct timespec lastmono,curmono;
  struct timespec lastreal,curreal;
  struct timespec checkinterval;
  checkinterval.tv_sec = 1;
  checkinterval.tv_nsec = 0;
  gettimeofday(&currentgtofday,0);
  lasttsc=  getTSCtimestamp();
  clock_gettime(CLOCK_MONOTONIC,&lastmono);
  clock_gettime(CLOCK_REALTIME,&lastreal);
  std::cout << "gettimeofday\ttsc\tdtsc\tmonotonic" << std::endl; 
  while(1)
  {
    nanosleep(&checkinterval,0);
    gettimeofday(&currentgtofday,0);
    currenttsc= getTSCtimestamp();
    clock_gettime(CLOCK_MONOTONIC,&curmono);
    clock_gettime(CLOCK_REALTIME,&curreal);
    std::cout << currentgtofday.tv_sec << '\t'
              << "\t" << currenttsc 
              << "\td" << (currenttsc-lasttsc)
              << "\t" << curmono
              << "\t" << curreal
	      << std::endl;
    lasttsc = currenttsc;
    lastmono = curmono;
  }
}
