#include<sys/time.h>

inline std::ostream& operator<<(std::ostream& str,struct timeval& tv)
{
    str << tv.tv_sec << "s " << tv.tv_usec << "us ";
    return str;
}

inline int  timeval_substract(struct timeval& result, const struct timeval& x,const struct timeval& y)
{
    /* Perform the carry for the later subtraction by updating y. */
    long ysec = y.tv_sec;
    if (x.tv_usec < y.tv_usec)
    {
	result.tv_usec = 1000000-y.tv_usec+x.tv_usec;
	ysec += 1;
    }
    else
    {
	result.tv_usec = x.tv_usec - y.tv_usec;
    }
    result.tv_sec = x.tv_sec - ysec;
    /* Return 1 if result is negative. */
    return x.tv_sec < y.tv_sec;
}
